import java.io.*;
import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;
import org.xml.sax.Locator;

public class WorkingSAXParserLocator extends DefaultHandler {
	private Locator locator;
	public static void main(String[] args) {
		try {
			BufferedReader bf = new BufferedReader(new InputStreamReader(System.in));
			System.out.print("Enter xml file name: ");
			String xmlFile = bf.readLine();
			File file = new File(xmlFile);
			if (file.exists()){
				XMLReader parser = XMLReaderFactory.createXMLReader();
				DefaultHandler handler = new WorkingSAXParserLocator();   
				parser.setContentHandler(handler);
				//parse xml file
				parser.parse(xmlFile);
			}
			else{
				System.out.println("File not found!");
			}
		}
		catch (Exception e) {
			System.err.println(e);
		}
	}
	public void setDocumentLocator(Locator locator) {
		this.locator = locator;
	}
	//All methods positions
	private void printLocation(String location) { 
		int line = locator.getLineNumber();
		int column = locator.getColumnNumber();
		System.out.println(location + "  Line no: " + line + "\tColumn no: " + column);
	}
	//Document start
	public void startDocument() { 
		printLocation("startDocument() method called at");
	}
	//Document end
	public void endDocument() { 
		printLocation("endDocument() method called at");
	}
	//Element start
	public void startElement(String namespaceURI, String localName, 
		String qualifiedName, Attributes atts) {
		printLocation("startElement() method called at ");
	}
	//Element end
	public void endElement(String namespaceURI, String localName, 
		String qualifiedName) {
		printLocation("endElement() method called at \t");
	}
	//characters
	public void characters(char[] text, int start, int length) {
		printLocation("characters() method called at \t"); 
	}
}